> ## Documentation Index
> Fetch the complete documentation index at: https://hoopdev-docs-improve-idp-sso-pages.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Plugin

> Update Plugin resource. The `config` and `name` attributes are immutable for this endpoint.



## OpenAPI

````yaml https://use.hoop.dev/api/openapiv3.json put /plugins/{name}
openapi: 3.0.3
info:
  contact:
    email: help@hoop.dev
    name: Help
    url: https://help.hoop.dev
  description: >-
    Hoop.dev is an access gateway for databases and servers with an API for
    packet manipulation
  license:
    name: MIT
    url: https://opensource.org/license/mit
  termsOfService: https://hoop.dev/docs/legal/tos
  title: Hoop Api
  version: 1.49.10
servers:
  - url: https://use.hoop.dev/api
security: []
tags:
  - description: >
      Hoop implements Oauth2 and OIDC protocol to authenticate users in the
      system. To obtain a valid access token users need to authenticate in their
      own identity provider which is generated as a JSON response to the
      endpoint `http(s)://use.hoop.dev/api/login`. The identity provider them
      redirects the user to the callback endpoint containing the access token.


      The recommended approach of obtaining an access token is by visiting the
      Webapp main's page or using the **Hoop command line**. Example:


      ```sh

      hoop config create --api-url https://use.hoop.dev

      # save the token after authenticating at $HOME/.hoop/config.toml

      hoop login

      # show token information

      hoop config view --raw

      ```


      With an access token you could use any HTTP client to interact with the
      documented endpoints.

      The token must be sent through the `Authorization` header.


      Example:


      ```sh

      # obtain the current configuration of the server

      curl https://use.hoop.dev/api/serverinfo -H "Authorization: Bearer
      $ACCESS_TOKEN"

      ```
    name: Authentication
  - description: >
      Users are active and assigned to the default organization when they
      signup. A user could be set to an inactive state preventing it from
      accessing the platform, however it’s recommended to manage the state of
      users in the identity provider.


      - The `sub` claim is used as the main identifier of the user in the
      platform.

      - The profile of the user is derived from the id_token claims `email` and
      `name`.


      When a user authenticates for the first time, it performs an automatic
      signup that persist the profile claims along with it’s unique identifier.

      ​

      ### Groups


      Groups allows defining who may access or interact with certain resources.


      - For connection resources it’s possible to define which groups has access
      to a specific connection, this is enforced when the Access Control feature
      is enabled.

      - For review resources, it’s possible to define which groups are allowed
      to approve an execution, this is enforced when the Review feature is
      enabled.


      > This resource could be managed manually via Webapp or propagated by the
      identity provider via ID Token. In this mode, groups are sync when a user
      performs a login.


      ### Roles


      - The `admin` group is a special role that grants full access to all
      resources


      This role should be granted to users that are responsible for managing the
      Gateway. All other users are regular, meaning that they can access their
      own resources and interact with connections.
    name: User Management
  - description: Routes used to manage and obtain information about the runtime server.
    name: Server Management
  - description: Features available in the gateway. See also **Plugin** resources.
    name: Features
  - description: >-
      Proxy manager endpoints controls how clients connect via gRPC in the
      gateway. These endpoints are meant to be used when a client is initialized
      via `hoop proxy-manager`.
    name: Proxy Manager
  - name: Connections
  - name: Agents
  - name: Runbooks
  - name: Guard Rails
  - name: Reviews
  - name: Sessions
  - name: Organization Management
  - name: Reports
paths:
  /plugins/{name}:
    put:
      tags:
        - Plugins
      summary: Update Plugin
      description: >-
        Update Plugin resource. The `config` and `name` attributes are immutable
        for this endpoint.
      parameters:
        - description: The name of the resource
          in: path
          name: name
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/openapi.Plugin'
        description: The request body resource
        required: true
        x-originalParamName: request
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.Plugin'
          description: OK
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.HTTPError'
          description: Bad Request
        '404':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.HTTPError'
          description: Not Found
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.HTTPError'
          description: Internal Server Error
components:
  schemas:
    openapi.Plugin:
      properties:
        config:
          allOf:
            - $ref: '#/components/schemas/openapi.PluginConfig'
          description: >-
            The top level plugin configuration. This value is immutable after
            creation
        connections:
          description: The list of connections configured for a specific plugin
          items:
            $ref: '#/components/schemas/openapi.PluginResourceConnection'
          type: array
        id:
          description: The resource identifier
          example: 15B5A2FD-0706-4A47-B1CF-B93CCFC5B3D7
          format: uuid
          readOnly: true
          type: string
        name:
          description: >-
            The name of the plugin to enable

            * audit - Audit connections

            * access_control - Enable access control by groups

            * dlp - Enable Google Data Loss Prevention (requires further
            configuration)

            * indexer - Enable indexing session contents

            * review - Enable reviewing executions

            * runbooks - Enable configuring runbooks

            * slack - Enable reviewing execution through Slack

            * webhooks - Send events via webhooks
          enum:
            - audit
            - access_control
            - dlp
            - indexer
            - review
            - runbooks
            - slack
            - webhooks
          example: slack
          type: string
        priority:
          default: 0
          description: DEPRECATED, should be always 0
          type: integer
        source:
          default: 'null'
          description: DEPRECATED, should be always null
          type: string
      required:
        - connections
        - name
      type: object
    openapi.HTTPError:
      properties:
        message:
          example: the error description
          type: string
      type: object
    openapi.PluginConfig:
      properties:
        envvars:
          additionalProperties:
            type: string
          description: >-
            The top level plugin configuration. The value is show as `REDACTED`
            after creation
          example:
            SLACK_APP_TOKEN: eC1hcHAtdG9rZW4=
            SLACK_BOT_TOKEN: eG94Yi10b2tlbg==
          type: object
        id:
          description: The resource identifier
          example: D9A998B3-AA7B-49B0-8463-C9E36435FC0B
          format: uuid
          readOnly: true
          type: string
      type: object
    openapi.PluginResourceConnection:
      properties:
        config:
          description: >-
            The configuration of the plugin connection, the content depends on
            the plugin type
          example:
            - EMAIL_ADDRESS
            - URL
          items:
            type: string
          type: array
        id:
          description: The connection ID reference
          example: B702C63C-E6EB-46BB-9D1E-90EA077E4582
          format: uuid
          type: string
        name:
          description: The name of the connection
          example: pgdemo
          type: string
      type: object

````